class Gamefic::Query::Available < Gamefic::Query::Base
  def context_from(subject)
    result = []
    top = subject.room || subject.parent
    unless top.nil?
      result.concat subquery_accessible(top)
    end
    result.delete subject
    subject.children.each do |c|
      result.push c
      result.concat subquery_accessible(c)
    end
    result
  end
end

class Gamefic::Query::Room < Gamefic::Query::Base
  def context_from(subject)
    subject.room ? [subject.room] : []
  end
end

Gamefic.script do
  set_default_query Gamefic::Query::Available
end
